/**
 * 
 */
package edu.udo.cs.ie.cowbots.bdi.brf;

import jason.asSyntax.Literal;
import edu.udo.cs.ie.cowbots.logic.*;

/**
 * this class represents an information object, which is
 * a tuple of an extended logic program and some meta
 * information.
 * 
 * @author Thomas, Boguslaw 
 */
public class InformationObject implements Comparable<InformationObject> {
	protected ELP elp;
	protected Meta meta;

	/**
	 * constructs an information object from given elp and meta
	 * @param e		initial elp
	 * @param m		initial meta information
	 */
	public InformationObject(ELP e, Meta m) {
		this.elp = e;
		this.meta = m;
	}
	
	public InformationObject(Literal l, Meta m) {
			
		this.elp = new ELP(l);
		this.meta = m;
	}
	
	public Meta getMeta() {
		return this.meta;
	}
	
	public ELP getELP() {
		return this.elp;
	}


	@Override
	public int compareTo(InformationObject o) {
		return o.getMeta().compareTo(this.getMeta());
	}

	@Override
	public String toString() {
		String ret = "information object:\nprogram:";
		ret += this.elp.toString();
		ret += "meta:\n"+this.meta.toString();
		return ret;
	}
}
