package edu.udo.cs.ie.cowbots.bdi.delib;

import edu.udo.cs.ie.cowbots.bdi.brf.IEpistemicState;
import edu.udo.cs.ie.cowbots.bdi.desgen.CDesire;
import edu.udo.cs.ie.cowbots.bdi.desgen.DefaultDesire;
import edu.udo.cs.ie.cowbots.bdi.desgen.DesireState;
import edu.udo.cs.ie.cowbots.bdi.desgen.IDesireState;
import jason.asSemantics.*;
import jason.asSyntax.ASSyntax;
import jason.asSyntax.Atom;
import jason.asSyntax.Literal;
import jason.asSyntax.LiteralImpl;
import jason.asSyntax.SourceInfo;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;
import jason.asSyntax.Trigger;
import jason.asSyntax.VarTerm;
import jason.asSyntax.Trigger.TEOperator;
import jason.asSyntax.Trigger.TEType;
import jason.asSyntax.parser.ParseException;
import jason.asSemantics.*;
import jason.stdlib.*;

import java.util.*;
import java.util.concurrent.ConcurrentLinkedQueue;

import java.util.logging.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * @author Alexander
 * 
 */

public class DeliberationComponent {
	/**
	 * @return the lastGoal
	 */
	public CDesire getLastGoal() {
		return lastGoal;
	}


	/**
	 * @param lastGoal the lastGoal to set
	 */
	public void setLastGoal(CDesire lastGoal) {
		this.lastGoal = lastGoal;
	}


	/**
	 * @return the k
	 */
	public double getK() {
		return k;
	}


	/**
	 * @param k the k to set
	 */
	public void setK(double k) {
		this.k = k;
	}


	private CDesire lastGoal;
	// planing complexity
	private double k = 1;
	// internal action
	private desire internalActionDesire;
	
	protected Logger logger;

	/**
	 * Empty constructor for DeliberationComponent.
	 */
	public DeliberationComponent(String agName) {
		internalActionDesire = new desire();
		logger = Logger.getLogger(agName + ".delib");
	}

	
	/**
	 * 
	 * More compact approach by Michael. No need for Goalstate. Chooses one
	 * Desire from the current Desirestate as Goal. If goal changes should
	 * occurs(agent pursues other goal than goal chosen from the desirestate )
	 * it decides, whether this change will or will not occurs. Called by
	 * CowbotAgent by selectEvent method
	 * 
	 * @param events
	 *            Agent's event Queue with triggers
	 * @param desireState
	 *            is the current Agent's Desirestate
	 * @param ts 
	 * 
	 * 
	 * 
	 */
	public Event reconsider(Queue<Event> events,
			IDesireState desireState, TransitionSystem ts) {
		
		
		if (events.peek().getTrigger().toString().equalsIgnoreCase(
				"+dummyEvent")) {
			// Current event was the dummy from desireGeneration
			// So remove this event from events and choose the next one
			events.poll();
		} else {
			// DH: Try to fix
			return events.poll();
		}
		

		CDesire topDesire = desireState.getMostMotivatedDesire();
		
		// fix: check if we have a desire at all. if not, pass through
		// event
		if (topDesire == null)
			return events.poll();

		// initial Desire arrives
		if (lastGoal == null) {
			lastGoal = topDesire;

			String trigger = "+!" + lastGoal.getUniqueName();

			logger.info("erzeuge neues goal: "+lastGoal.getUniqueName());
			
			return new Event(Trigger.parseTrigger(trigger), Intention.EmptyInt);						

		}
		
		if (lastGoal.getUniqueName().toString().equalsIgnoreCase(
					topDesire.getUniqueName().toString())) {

			// kein goalwechsel bei gleichen Goals
			//System.out.println("kein goalwechsel:"
			//		+ lastGoal.getUniqueName().toString());

			logger.info("kein goalwechsel:" + lastGoal.getUniqueName().toString());
			// prfen ob neues event erzeugt werden muss, weil der plan
			// fr das ziel fehlgeschlagen oder fertig ist.
			// Es wird die schon in jason vorhandene interne aktion .desires
			// dafr benutzt
			if (!internalActionDesire.desires(ts.getC(), lastGoal.getUniqueName(), new Unifier())) {
				logger.info("erzeuge neues event fr "
						+ lastGoal.getUniqueName());
				String trigger = "+!" + lastGoal.getUniqueName();
				return new Event(Trigger.parseTrigger(trigger),
						Intention.EmptyInt);
			} else {
				return events.poll();
			}
			
		}
		
		if ((lastGoal.getIntensity() * k) < (topDesire.getIntensity())) {
			// goal changes due to intensity, where k is a constant to
			// prevent
			// reconsidering too often

			lastGoal = topDesire;

			// wir verfolgen weiterhin das zuletzt verfolgte ziel
			logger.info("goalwechsel: " + topDesire);
			String trigger = "+!" + lastGoal.getUniqueName();
			return new Event(Trigger.parseTrigger(trigger),	Intention.EmptyInt);
		
		} else {
			/*
			Event evn = events.peek();
			if (evn == null) {
				
				logger.info("kein goalwechsel: null, lastGoal="+lastGoal.getUniqueName());// +evn.toString());				
				if (!internalActionDesire.desires(ts.getC(), lastGoal.getUniqueName(), new Unifier())) {
					logger.info("erzeuge neues event fr "+ lastGoal.getUniqueName());
					String trigger = "+!" + lastGoal.getUniqueName();
					return new Event(Trigger.parseTrigger(trigger),Intention.EmptyInt);
				}
			} else {
				logger.info("kein goalwechsel: lastGoal="+lastGoal.getUniqueName());// +evn.toString());
			}
			return events.poll();
			*/
			
			// TODO: DH Try to fix
			logger.info("kein goalwechsel: null, lastGoal="+lastGoal.getUniqueName());// +evn.toString());				
			if (!internalActionDesire.desires(ts.getC(), lastGoal.getUniqueName(), new Unifier())) {
				logger.info("erzeuge neues event fr "+ lastGoal.getUniqueName());
				String trigger = "+!" + lastGoal.getUniqueName();
				return new Event(Trigger.parseTrigger(trigger),Intention.EmptyInt);
			} else return events.poll();
			
		}
		
	}
	
	
	/**
	 * this method handles received, but yet unprocessed messages.
	 * it allows the deliberation component to react to other
	 * agent's requests and belief or disbelief them.
	 * 
	 * @param es
	 * @param ts
	 */
	public void reconsiderMessage(IEpistemicState es, TransitionSystem ts, String agName) {
		Queue<Message> msgQueue = es.getMessages();
		
		while( msgQueue.peek() != null ) {
			Message m = msgQueue.poll();
			Term content = null;
	        if (m.getPropCont() instanceof Term) {
	            content = (Term)m.getPropCont();
	        } else {
	            try {
	                content = ASSyntax.parseTerm(m.getPropCont().toString());
	            } catch (ParseException e) {
	                //logger.warning("The content of the message '"+m.getPropCont()+"' is not a term!");
	            }
	        }
	        
	        String sender = m.getSender();
	        if (sender.equals(agName))
	            sender = "self";
	        Literal received = new LiteralImpl("kqml_received").addTerms(
	                new Atom(sender),
	                new Atom(m.getIlForce()),
	                content,
	                new Atom(m.getMsgId()));
	        
	    	ts.updateEvents(new Event(new Trigger(TEOperator.add, TEType.achieve, received), Intention.EmptyInt));
		}
	}


	/**
	 * called by CowbotAgent by selectOption method Returnes one Option (Plan)
	 * from all available Plans, that were unified with current Trigger.
	 */
	public Option choose(List<Option> options) {
		if (options != null && !options.isEmpty()) {
			return options.remove(0);
		} else {
			return null;
		}
	}

	
	/**
	 * Picks the intention for the current goal from a Queue of intentions.
	 * Removes other intentions from the Queue
	 * 
	 * @param intentions
	 *            the current List of Intentions the Agent has
	 * 
	 * @return Intention for the current Goal
	 */

	public Intention select(Queue<Intention> intentions) {
		return intentions.poll();
	}

	
}
