package edu.udo.cs.ie.cowbots.bdi.desgen;

import jason.asSyntax.Literal;

import java.util.LinkedList;

/**
 * Implementation of a cowbots desirestate.
 *  For reference see the javadoc in IDesireState.
 *  
 * @author dhoelzgen
 *
 */
public class DesireState extends LinkedList<CDesire> implements IDesireState {

	/**
	 * Returns the intensity of the desire identified by the
	 * given unique name. If the desire does not exist, zero
	 * is returned. 
	 */
	@Override
	public int getIntensityByUniqueName(Literal uniqueName) {
		try {
			for (CDesire des : this) {
				if (des.getUniqueName().toString().equals(uniqueName.toString()))
					return des.getIntensity();
			}
		} catch (Exception ex) {
			System.err.println("Could not find desire by unique name: " + uniqueName.toString());
		}
		return 0;
	}
	
	/**
	 * Returns the desire with the highest intensity
	 * 
	 * TODO: Ugly, but we cannot use TreeSet because we need
	 * equals *and* compareTo with different meanings
	 */
	@Override
	public CDesire getMostMotivatedDesire() {
		try {
			CDesire mostMotivatedDesire = this.getFirst();

			for (CDesire des : this) {
				if (des.compareTo(mostMotivatedDesire) > 0)
					mostMotivatedDesire = des;
			}

			return mostMotivatedDesire;
		} catch (Exception ex) {
			// TODO: Error handling
		}

		System.err.println("Desirestate is empty.");
		return null;
	}

}
