package edu.udo.cs.ie.cowbots.elpParser.dlp;

import edu.udo.cs.ie.cowbots.logic.NegLiteral;
import edu.udo.cs.ie.cowbots.logic.NotLiteral;

/**
 * class for default negated literals
 * 
 * @author Wei
 * @see super class {@link NegLiteral} and interface {@link DLPLiteral}
 */
public class DLPNotLiteral extends NotLiteral implements DLPLiteral {
	DLPLiteral lit;
	
	public DLPNotLiteral(DLPLiteral arg) {
		this.lit = arg;
	}

	@Override
	public DLPLiteral getLiteral() {
		return lit;
	}

	@Override
	public boolean isAtom() {
		return false;
	}

	@Override
	public boolean isDefaultNegated() {
		return true;
	}

	@Override
	public boolean isStrictNegated() {
		return lit.isStrictNegated();
	}

	@Override
	public DLPAtom getAtom() {
		return (DLPAtom) this.lit.getAtom();
	}
	
	public String toString() {
		return "not "+lit.toString();
	}

	@Override
	public boolean isArithmetic() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean LitIsAfact(boolean b) {
		// TODO Auto-generated method stub
		return false;
	}


}
