package edu.udo.cs.ie.cowbots.elpParser.dlp;

import java.util.Collection;
import java.util.HashSet;


/**
 * Operators which in used by list of terms
 * @author Wei 
 * @see DLPTermList and {@link DLPTerm}
 */
public class DLPOperator implements DLPTerm{
	
	private String actualOp;
	private HashSet<String> arith;
	private HashSet<String> comp;
	private boolean isCompOP=false;
	private boolean isArithOP=false;
	
	
	public DLPOperator(){
		
		arith.add("+");
		arith.add("-");
		arith.add("*");
		arith.add("/");
		arith.add("%");
		arith.add("=");
		comp.add("<");
		comp.add(">");
		comp.add("==");
		comp.add("<=");
		comp.add(">=");
		comp.add("!=");
		
	}
	
	public DLPOperator(String n){
		
		arith.add("+");
		arith.add("-");
		arith.add("*");
		arith.add("/");
		arith.add("%");
		arith.add("=");
		comp.add("<");
		comp.add(">");
		comp.add("==");
		comp.add("<=");
		comp.add(">=");
		comp.add("!=");
		
		if ((n == null) | (n == ""))			
			System.out.println("the name of operator is invalid!");
		
		else if (arith.contains(n)||comp.contains(n))			
			actualOp = n;
		
		else
			System.out.println("this is not a name of operator!");
		
	}
	
	/**
	 * get actual operator from alternative operator list back
	 * @param name the name of operator {@link String}
	 * @return {@link DLPOperator#actualOp}
	 */
	public String getOperator(String name){
		
		HashSet<String> ops = new HashSet<String>();
		ops.addAll(arith);		
		ops.addAll(comp); 
		
		if(name!=""|name!=null)
			for (String op : ops) {
				
				if(op.equals(name)&&!arith.add(op)){
					isArithOP(true);
					isCompOP(false);
					actualOp = name;
					return getName();
				}
				
				if(op.equals(name)&&!comp.add(op)){
					isArithOP(false);
					isCompOP(true);
					actualOp = name;
					return getName();
				}
				
			}		
		return "(noDefinedOperator)";			
	}
    	
	/**
	 * switch to identify whether that operator is arithmetic or not
	 * @param b identifier {@link Boolean}
	 * 
	 */
	public void isArithOP(boolean b){
		isArithOP=b;
	}
	
	public boolean isArithOP(){
		return isArithOP;
	}
	
	/**
	 * switch to identify whether that operator is comparative or not
	 * @param b identifier {@link Boolean}
	 * 
	 */	
	public void isCompOP(boolean b){
		isCompOP=b;
	}
	
	public boolean isCompOP(){
		return isCompOP;
	}
	
	@Override

	public String getName(){
		// TODO Auto-generated method stub
		return actualOp;
	}
	
	public String toString(){
		
		if(arith.contains(actualOp))
			return "This arithmetic operator is "+actualOp+".";
		
		else if(comp.contains(actualOp))
			return "This arithmetic operator is "+actualOp+".";
		
		else 
			return "Do can't tell u what an operator is that.";
		
	}

	@Override
	public boolean isOperator() {
		// TODO Auto-generated method stub
		return true;
	}


	
}
