package edu.udo.cs.ie.cowbots.internalActions.Leader;

import java.util.Collection;
import java.util.List;
import java.util.ListIterator;
import java.util.TreeMap;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.*;
/**
 * 
 * Java methods to make Helper and Rejected Lists
 * args[0] howMuchDoesTheyWant(Agent,GoalIntensity)
 * args[1] groupSize
 *  AgentsList,GroupSize,HelperList,RejectedList);
 * (AgentsList,GroupSize,HelperList,RejectedList);
 * @author Michael, Alex
 *
 */

public class makeAckRejLists extends DefaultInternalAction {

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
			
		List<Term> liste = ((VarTerm) args[0]).getAsList();			
		//ListTermImpl liste = (ListTermImpl) ((VarTerm) args[0]).getAsListOfTerms();
		int groupSize = (int) ((NumberTerm) args[1]).solve();
		
		
		ListIterator<Term> iterator = liste.listIterator();
		if(liste.size()<groupSize){
			System.out.println("groupSize too small");
			return false;			
		}
		ListTermImpl listeAck = new ListTermImpl();
		ListTermImpl listeRej = new ListTermImpl();
		int count=0;
		Integer keyIntensity;
		Term valueName;
		TreeMap<Integer, Term> map= new TreeMap<Integer, Term>();
		while(iterator.hasNext()){			
			Literal current = (Literal)iterator.next();
			
			keyIntensity=(int)(((NumberTerm) current.getTerms().get(1)).solve());
			valueName=current.getTerms().get(0);
			while(map.containsKey(keyIntensity)){
				keyIntensity--;
			}
			map.put(keyIntensity, valueName);
		}
		map.descendingMap();
		Collection<Term> values = map.values();
		//System.out.println("values="+values);
		for(Term cur: values){
			if(count<groupSize){
				listeAck.add(cur);
				count++;
			}else{
				listeRej.add(cur);
			}
		}
			
		un.unifies(listeAck, args[2]);
		un.unifies(listeRej, args[3]);		
		return true;
	}

	
}


