package edu.udo.cs.ie.cowbots.internalActions.experimental2;

import java.awt.Point;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.bdi.brf.BeliefSet;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.planer.makePlan;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.*;
import jason.asSyntax.*;
import jason.asSemantics.*;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;

/**
 * 
 * @author dhoelzgen
 *
 */
public class exRandomScoutPosition extends DefaultInternalAction {
	
	/**
	 * Modified scout destination finder. Returns a new scout position, tries to
	 * find a position which is unexplored. Will not return a positon on an obstacle
	 * or in own corral.
	 */
	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
		
		ICowbot cowbot = (ICowbot) ts.getAg();
		GridMap map = cowbot.getEpistemicState().getMap();
		
		Point randomtarget = calculateRandomTarget(map, 0);
		
		un.unifies(args[0], new NumberTermImpl(randomtarget.x));
		un.unifies(args[1], new NumberTermImpl(randomtarget.y));

		return true;
	}

	/**
	 * Utility function for calculating a random target in the world, which is
	 * not a switch or an obstacle
	 * 
	 * @return	Point encoding the coordinates
	 */
	private Point calculateRandomTarget(GridMap map, int i) {

		int x = (int) (Math.random() * map.width());
		int y = (int) (Math.random() * map.height());
		
		if(x == 0) x++;
		if(y == 0) y++;
		
		if(x == map.width()) x--;
		if(y == map.height()) y--;
		
		System.err.println("CHECKING " + x + ", " + y + ": " + map.getCell(x, y).cell_content.toString());
		
		boolean corralBlocker = false;
		if (map.getBgnd(x, y) != null) {
			if (map.getBgnd(x, y).getLiteral().toString().contains("owncorral"))
				corralBlocker = true;
		}
		
		if (i < 20 && map.getCell(x, y).cell_content.toString().contains("unexplored"))
			return (new Point(x, y));
		else if (i < 20)
			return calculateRandomTarget(map, ++i);
		else if (map.getCell(x, y).isObstacle 
				|| map.getCell(x, y).isSwitch
				|| corralBlocker)
			return calculateRandomTarget(map, ++i);
		else return (new Point(x, y));

	}
}
