package edu.udo.cs.ie.cowbots.internalActions;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Term;
import jason.asSyntax.ListTerm;
import jason.asSyntax.ListTermImpl;
import jason.asSyntax.Literal;
import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import java.util.List;

/**
 * internal action that returns a term list with
 * all new explored cells and cows that an agent 
 * recently perceived.
 * 
 * @author Thomas
 *
 */
public class getExploredCells extends DefaultInternalAction {
	public Object execute(TransitionSystem ts, Unifier un, Term[] args) throws Exception {
		
		if (args.length != 1)
			throw new Exception("getExplorations error: exactly one argument is requried");
		
		ICowbot ic = (ICowbot) ts.getAg();
		List<ELPLiteral> explored = ic.getEpistemicState().getExploredCells();
		ListTerm lt = new ListTermImpl();
		lt.add( Literal.parse("messagecontent(exploredcells)"));
			if (explored != null) {
			for (ELPLiteral l : explored) {
				lt.add( Literal.parse(l.toString()));
			}
			ic.getEpistemicState().getExploredCells().clear();
			}
		un.unifies( lt, args[0] );
				
		return true;
	}
}
