package edu.udo.cs.ie.cowbots.logic;

import java.util.*;

/**
 * this class represents a symbolic set, which is
 * a set of local variables over a set of literals.
 * 
 * @author Thomas
 *
 */
public class SymbolicSet {
	
	List<String> 		variables = new LinkedList<String>();
	List<ELPLiteral>	literals = new LinkedList<ELPLiteral>();
	
	public SymbolicSet() {
		
	}
	
	public void addVariable(String varname) {
		this.variables.add(varname);
	}
	
	public void addLiteral(ELPLiteral lit) {
		this.literals.add(lit);
	}
	
	public List<String> getVariables() {
		return this.variables;
	}
	
	public List<ELPLiteral> getLiterals() {
		return this.literals;
	}
	
	@Override
	public String toString() {
		String ret = "{";
		boolean first = true;
		for (String v : variables) {
			if (!first)
				ret += ",";
			ret += v;
			first = false;
		}
		ret += ":";
		first = true;
		for (ELPLiteral l : literals) {
			if (!first)
				ret += ",";
			ret += l;
			first = false;
		}
		ret += "}";
		return ret;
	}
}
