package edu.udo.cs.ie.cowbots.logic.solver;

import java.util.*;

import edu.udo.cs.ie.cowbots.logic.ELPLiteral;

import jason.asSyntax.*;

/**
 * a class representing the result of a solver
 * feeded with some elps. beside facts generated
 * by an anwser set, it provides additional
 * information like answer set weight (default is 0).
 * 
 * the empty answer set is returned with as a
 * set with zero literals.
 * 
 * @author Thomas
 *
 */
public class AnswerSet  {
	
	public AnswerSet(Set<ELPLiteral> lits, int weight, int level) {
		literals = lits;
		this.weight = weight;
		this.level = level;
	}
	
	public final int				weight;
	public final int				level;
	public final Set<ELPLiteral>	literals;
}
