package edu.udo.cs.ie.cowbots.planer;

import java.util.Stack;
import java.util.StringTokenizer;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;

import jason.asSyntax.Literal;
import jason.asSyntax.PlanBody;
import jason.asSyntax.PlanBodyImpl;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;
import jason.asSyntax.PlanBody.BodyType;

/**
 * 
 * Java methods to get a plan from on the intendes means
 * 
 * @author Michael, Alex
 *
 */

public class getPlan extends DefaultInternalAction {

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
		
		//super.execute(ts, un, args);
		
		//System.out.println("vor planung: "+ts.getC().getSelectedIntention());
		placePlanOnIntendetMeans(args[0].toString(),ts);
		//System.out.println("nach planung: "+ts.getC().getSelectedIntention());
		
		return true;
	}

	/**
	 * this method puts the plan (in form of a string)
	 * on jason's intended means
	 * 
	 * @param plan	
	 * @param ts
	 * @throws Exception
	 */
	private void placePlanOnIntendetMeans(String plan, TransitionSystem ts) throws Exception
	{
		BodyType BT;
		//Stack<IntendedMeans> im = ts.getC().getSelectedIntention().getIMs();
		IntendedMeans im = ts.getC().getSelectedIntention().peek();
		plan = plan.replaceAll("\\\\ \"", "");
		plan = plan.trim();
		//System.out.println("trimmed plan: "+plan);
		String steps[] = plan.split(";");
		System.out.println("planlnge: "+steps.length);
		PlanBody newpb = null;
		for (int i = 0; i <= steps.length - 2; i++) {
			String currentStep = steps[i].trim();
			if (i == 0) {
				currentStep = currentStep.substring(1);
			}
			if (currentStep.length()<=0)
				continue;
			
			if (currentStep.startsWith("?")) {
				currentStep=currentStep.substring(1);
				BT = BodyType.test;
			}
			else if(currentStep.startsWith("-")){
				currentStep = currentStep.substring(1);
				BT = BodyType.delBel;
				} else {
					BT = BodyType.action;
				}
		
			
		
			// plan muss vollstndig aufgebaut werden, bevor er
			// als nchster schritt zu den intended means darf.
			if (newpb == null)
				newpb = new PlanBodyImpl(BT, Literal.parse(currentStep));
			else
				newpb.add( new PlanBodyImpl(BT,Literal.parse(currentStep)));
		//System.out.println("new plan body: " + newpb);
		//im.insertAsNextStep(newpb);
		}
		im.insertAsNextStep(newpb);
	}
	
}


