package edu.udo.cs.ie.cowbots.util.cluster;

import java.util.List;

import edu.udo.cs.ie.cowbots.util.GridMap;
import edu.udo.cs.ie.cowbots.util.DistanceMap;

/**
 * basic interface for all cluster generator algorithms.
 * based on the ClusterCalculator written by dhoelzgen.
 * 
 * @author Thomas
 *
 */
public interface IClusterCalculator {

	/**
	 * this method returns a set of clusters of cows
	 * derived from the current world view of an agent.
	 * 
	 * @param map	GridMap representing an agents view of the world
	 * @param dm	DistanceMap for fast cow2corral lookup
	 * @param cDist	maximum allowed cluster elongation
	 * @param maxCowTime	maximum age of cows to respect during clustering
	 * @return	list of cow cluster
	 */
	public List<CowCluster> getCowClusters(GridMap map, DistanceMap dm, int cDist,
			int maxCowTime);

}