{include ("exWalker.asl")}
{include ("cbfunk.asl")}

// locateBorderGate(GateDirection, AgentDirection, Xoffset, Yoffset)
// locateBorderGate is used to iterate over a gate that is orientated at the given axis (1. argument) and go into the given direction (2. argument)
// the 3. and 4. value determine the change in coordinates (x and y) needed for one step. 
// since negative values are not allowed the 3. and 4. argument equal to the (coordinatechange +1)
locateBorderGate(xaxis, east, 2, 1).
locateBorderGate(xaxis, west, 0, 1).
locateBorderGate(yaxis, north, 1, 2).
locateBorderGate(yaxis, south, 1, 0).

// toggleSwitch determines where the (most common) position to open a switch from each side of the game is
// the first argument determines whether the agents are in front of the gate (to open it) or have passed it already (to keep it open, so that the original opener can regroup with the team)
// the second argument determines the direction of the fenceopenWP to the gate (so basically the original orientation of the agents to the gate)
// the third and fourth value determine the change in coordinates (x and y) of the original switch position
// since negative values are not allowed the third and fourth argument equal to the (coordinatechange +1)
toggleSwitch(outside, north, 1, 2).
toggleSwitch(outside, east, 0, 1).
toggleSwitch(outside, south, 1, 0).
toggleSwitch(outside, west, 2, 1).


// getGateOrthogonal projects a gate orientation (first argument) and a waypointDirection (second argument) to the part of the waypointDirection, which is orthogonal to the gate orientation (third argument)
getGateOrthogonal(xaxis, south, south).
getGateOrthogonal(xaxis, north, north).
getGateOrthogonal(xaxis, northeast, north).
getGateOrthogonal(xaxis, northwest, north).
getGateOrthogonal(xaxis, southeast, south).
getGateOrthogonal(xaxis, southwest, south).

getGateOrthogonal(yaxis, east, east).
getGateOrthogonal(yaxis, west, west).
getGateOrthogonal(yaxis, southeast, east).
getGateOrthogonal(yaxis, southwest, west).
getGateOrthogonal(yaxis, northeast, east).
getGateOrthogonal(yaxis, northwest, west).


// getAgentSide relates the direction of the gate in relation to the agents (1. argument) 
// and a given side, in which the agent should perform his search, (second argument) to the adequate direction (third argument)
getAgentSide(east, right, north).
getAgentSide(east, left, south).
getAgentSide(west, right, south).
getAgentSide(west, left, north).

getAgentSide(north, right, east).
getAgentSide(north, left, west).
getAgentSide(south, right, west).
getAgentSide(south, left, east).

 
 /*
// TESTLITERAL
!helped(admetus, cowdriving, cow1). 
*/
   
   
+!helped(A,T,C): 
		becomeDooropener[source(A)]
<- 	!dooropeningHelping(A);
	-+succstepsreconsider(8).
//	!helped(A,T,C). //TODO: fuer trockentests, muss spaeter entfernt werden


+!scouted: 
		becomeDooropener[source(A)]
<- !dooropeningHelping(A).


+!dooropeningHelping(A):  openSwitch(X,Y)[source(A)]
<-	!openSwitch;
	-openSwitch(X,Y)[source(A)].

+!dooropeningHelping(A): startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)]
<-	!startLookingForSwitch;
	-startLookingForSwitch(_,_,_,_,_).
	

+!dooropeningHelping(A): checkDistance(S, X, Y)[source(A)]
<- 	!checkDistance;
	-checkDistance(S,X,Y)[source(A)].

+!dooropeningHelping(A): isPassed(F, Fx, Fy, GD)[source(A)]
<- 	!buildTempGate(F,Fx,Fy);
	!fencePassed;
	?gatePassed(F, Fx, Fy, B);
	.send(A, tell, gatePassed(F, Fx, Fy, B));
	-isPassed(F, Fx, Fy, GD)[source(A)].
   

+!dooropeningHelping(A):
	waypoint(startwp,_,_,_,X,Y,_,D,P,_,_) 
//	& not iamAtSwitch  
	& iam(Me)
<-	.print("Helping ",A, " walking on");
	edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(X, Y, P, D, ExpX, ExpY);
	.print("Start walking to ",ExpX,",",ExpY);
	?succstepsreconsider(RecSteps);
	-+succstepsreconsider(1);
	edu.udo.cs.ie.cowbots.planer.makePlan(reach,ExpX,ExpY,Me);
	-+succstepsreconsider(RecSteps);
	!reach;
	.print("Reached.");
	// Try to fix, that loop of this plan ignores everything else
	//-waypoint(startwp,drivencow,_,_,_,_,_,_,_,_,Q)[source(_)];
	.wait(1000).	

	
+!dooropeningHelping(A): fencePassed[source(A)]
<-
	-fencePassed;
	-becomeDooropener[source(A)];
	.print("Dooropenerrolle wird abgelegt").

+dooropeningHelping(A) : iamAtSwitch
<-  .print("Not walking through, holding Switch open");
	.wait(1000).

//standardfall, keine nachrichten --> abwarten (rekursiv). 
+!dooropeningHelping(A): true 
<-
	.print("Warte auf Anweisungen");
    .wait(2000).
	//!dooropeningHelping(A).
 
 -!dooropeningHelping(A):true
 <- .print("Dooropeninghelping failed");
 	.wait(1000).
   
 
// !openSwitch is triggered, when the agent receives the openSwitch(X,Y) literal. he will try to open the switch at the position (X,Y).
// possible improvement: change to +openSwitch(X,Y)[source(A)]
+!openSwitch : openSwitch(X,Y)[source(A)]
<-  .print("Start openSwitch");
	?iam(N); 
   //.print("ich bin ", N);
   ?ison(N,X1,Y1,_);
   //.print("ich bin auf Position (", X1, ", ", Y1, ")");
  // -walkingfailed; 
  // !setWalkingModi(0,1,0);
   .print("OpenSwitch: Try walking to ", X,Y);
   	?iam(Me);
	edu.udo.cs.ie.cowbots.planer.makePlan(reach,X,Y,Me);
	!reach;
   .print("OpenSwitch: Reached");
   !setWalkingModi(0,0,0);
   .wait(100);
   !checkDestination.
   
   

   
//success: der agent ist auf dem zielfeld angekommen
+!checkDestination : 
		ison(Ag, X, Y,_) & openSwitch(X,Y)[source(Bg)] & iam(Ag)
<-
   .print("bin am Schalter angekommen");
   .send(Bg, tell, arrivedAtSwitch(X, Y));
   -openSwitch(X,Y)[source(Bg)];
   .wait(100).
   
// !startLookingForSwitch is called as soon as the agent receives the startLookingForSwitch literal. he tries to locate the switch of the given gate
// possible improvement: see above
+!startLookingForSwitch: startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)]
<-
	.print("Ich soll helfen einen Schalter zu finden");
	!buildTempGate(F, Fx, Fy);
	!lookForSwitch;
	.wait(100).	
	
-!startLookingForSwitch
<- .print("Cannot startLookingforSwitch");
	.wait(1000).	
	
	
// !checkDistance is called as soon as the agent receives the checkDistance literal. he checks his distance to the given coordinates and replies.
// possible improvement: see above	
+!checkDistance : checkDistance(S, X, Y)[source(A)]
<-
	.print("Ich soll meine Distanz zu ", S, " zurueckgeben.");
	?iam(N);
	?ison(N, X2, Y2, T);
	edu.udo.cs.ie.cowbots.internalActions.scout.distanceToCP(X2,Y2,X,Y,V);
	.send(A, tell, distanceToSwitch(S, X, Y, V, T)).
		

// !lookForSwitch is the actual search for the switch (in contrast to startLookingForSwitch). the agent will walk along the fence according to his direction as long as no switch is found.
+!lookForSwitch : 
	startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)] 
	& switchFound(F, Fx, Fy, S, X, Y)
<-	
	.print("Ein Switch wurde (von einem anderen Agenten) gefunden");
	-switchFound(F, Fx, Fy, S, X, Y);
	-startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)].
	


+!lookForSwitch : 
	startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)] 
	& ison(S,X,Y,T) & switch(S) 
	& tempGate(X, Y, G) & tempGate(Fx, Fy, G)
<-
	.print("sehe Switch");
	.send(A, tell, switchDetected(S, X, Y, T));
	-startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)] ;
	.wait(100).		
	

	
+!lookForSwitch(F, Fx, Fy, GD, AD, A) : 
	startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)] & gateAxis(unknown)
<-	
	.print("das gate kann nicht vollstaendig erkannt werden. Versuche Gate neu aufzubauen.");
	-tempGate(_,_,_);
	!buildTempGate(F, Fx, Fy);	
	.wait(100).
	
	
+!lookForSwitch : 
	startLookingForSwitch(F, Fx, Fy, GD, AD)[source(A)] 
	& tempGate(X, Y, G)  & tempGate(Fx, Fy, G)
	& locateBorderGate(Axis, Direction, Xoff, Yoff) 
	& not (tempGate(Xg, Yg, G) & (Xg = X + (Xoff-1)) & (Yg = Y + (Yoff-1))) 
	& toggleSwitch(outside, Ortho, Xt, Yt)
	& getGateOrthogonal(Axis, GD, Ortho)
	& gateAxis(Axis)
	& getAgentSide(Ortho, AD, Direction)
<-	.print(Axis, GD, Ortho);
	.print("suche Switch in Richtung ", Direction);
	.print("laufe auf ", (X + (Xt - 1)), ",", (Y + (Yt - 1)));
	.wait(100);
   	!setWalkingModi(0,0,0);
   	.print("walkmodi set");
	!walkTo((X + (Xt - 1)),(Y + (Yt - 1)), Direction);
	.print("reached");
	//-tempGate(_,_,_);
	!buildTempGate(F, Fx, Fy).

-!lookForSwitch
<- .print("lookForSwitch failed");
	.wait(500).

// !buildTempGate is a temporary solution to support gates without switches (it has already been integrated as elp into the brf)

+!buildTempGate(F, Fx, Fy) : not tempGate(Fx, Fy, Gn) & .concat("_", F, Fx, Fy, Gn)
<- +tempGate(Fx, Fy, Gn);
	-+gateAxis(unknown);
	.print("fuege tempGate ", Fx, Fy, " hinzu");
	!buildTempGate(F, Fx, Fy).
		
+!buildTempGate(F, Fx, Fy) : 
	tempGate(Gx, Gy, Gn) & tempGate(Fx, Fy, Gn)
	& ison(O, X, Y, _) & (switch(O) | fence(O)) 
	& (locateBorderGate(yaxis, north, Xoff, Yoff) | locateBorderGate(yaxis, south, Xoff, Yoff))
	& (Gx = X + (Xoff-1)) & (Gy = Y + (Yoff-1))
	& not (tempGate(X, Y, G)) 
	& not gateAxis(xaxis)
<- +tempGate(X, Y, Gn);
	-+gateAxis(yaxis);
	.print("fuege tempGate ", X, Y, " hinzu", yaxis);
	!buildTempGate(F,Fx,Fy).

+!buildTempGate(F, Fx, Fy) : 
	tempGate(Gx, Gy, Gn) & tempGate(Fx, Fy, Gn)
	& ison(O, X, Y, _) & (switch(O) | fence(O)) 
	& (locateBorderGate(xaxis, east, Xoff, Yoff) | locateBorderGate(xaxis, west, Xoff, Yoff))
	& (Gx = X + (Xoff-1)) & (Gy = Y + (Yoff-1))
	& not (tempGate(X, Y, G)) 
	& not gateAxis(yaxis)
<- +tempGate(X, Y, Gn);
	-+gateAxis(xaxis);
	.print("fuege tempGate ", X, Y, " hinzu", xaxis);
	!buildTempGate(F,Fx,Fy).

			
+!buildTempGate(F, Fx, Fy) 
<- .print("gate komplett", ",", F, ",", Fx, ",", Fy).


// !fencePassed checks if the agent has passed the given fence and replies
// possible improvement: see above
+!fencePassed : isPassed(F, Fx, Fy, D)[source(Leader)]
	& tempGate(Fx, Fy, Gn) & tempGate(Gx, Gy, Gn)
	& iam(N) & ison(N, X, Y, _) 
	& gateAxis(Axis) & getGateOrthogonal(Axis, D, Ortho)
	& Ortho = south & X = Gx & Y > Gy
<-  
	.print("fencePassed true; mchte durch das Tor Richtung: ", Ortho);
	-+gatePassed(F, Fx, Fy, true).

+!fencePassed : isPassed(F, Fx, Fy, D)[source(Leader)]
	& tempGate(Fx, Fy, Gn) & tempGate(Gx, Gy, Gn)
	& iam(N) & ison(N, X, Y, _) 
	& gateAxis(Axis) & getGateOrthogonal(Axis, D, Ortho)
	& Ortho = north & X = Gx & Gy > Y
<-
	.print("fencePassed true; mchte durch das Tor Richtung: ", Ortho);
	-+gatePassed(F, Fx, Fy, true).

+!fencePassed : isPassed(F, Fx, Fy, D)[source(Leader)]
	& tempGate(Fx, Fy, Gn) & tempGate(Gx, Gy, Gn)
	& iam(N) & ison(N, X, Y, _) 
	& gateAxis(Axis) & getGateOrthogonal(Axis, D, Ortho)
	& Ortho = east & Y = Gy & X > Gx
<-
	.print("fencePassed true; mchte durch das Tor Richtung: ", Ortho);
	-+gatePassed(F, Fx, Fy, true).

+!fencePassed : isPassed(F, Fx, Fy, D)[source(Leader)]
	& tempGate(Fx, Fy, Gn) & tempGate(Gx, Gy, Gn)
	& iam(N) & ison(N, X, Y, _) 
	& gateAxis(Axis) & getGateOrthogonal(Axis, D, Ortho)
	& Ortho = west & Y = Gy & Gx > X
<-
	.print("fencePassed true; mchte durch das Tor Richtung: ", Ortho);
	-+gatePassed(F, Fx, Fy, true).

+!fencePassed : isPassed(F, Fx, Fy, D)[source(Leader)]
<-
	?gateAxis(Axis);
	?getGateOrthogonal(Axis, D, Ortho);
	.print("fencePassed false; Ortho: ", Ortho);
	-+gatePassed(F,Fx,Fy,false).


// destructor
+!abolishDoorOpeningHelperPlan : true
<- 
  !debugprint("Im in abolishDoorOpeningHelperPlan : true" );
  -becomeDooropener;
  -openSwitch(_,_);
  -startLookingForSwitch(_,_,_,_,_);
  -checkDistance(_,_,_);
  -isPassed(_, _, _, _);
  -switchFound(_, _, _, _, _, _);
  -gatePassed(_, _, _, _).
  
	
