walkfailscount(0).
stepcount(0).
walkingfailstolerance(3).

surroundCows(1).
ignoreFences(0).


// Beliefs to assure that the Reach Plan passes fences correctly

relateDirection(northwest, 0, 0).
relateDirection(southeast, 2, 2).
relateDirection(northeast, 2, 0).
relateDirection(southwest, 0, 2).

relateWalkAlternatives(northeast, north, east).
relateWalkAlternatives(southeast, south, east).
relateWalkAlternatives(northwest, north, west).
relateWalkAlternatives(southwest, south, west).





+!setWalkingModi(SC,IF,IA) : true
<-	-surroundCows(_);
    -ignoreFences(_);
    -ignoreAlly(_);
    +surroundCows(SC);
    +ignoreFences(IF);
    +ignoreAlly(IA).
		
+!walkTo(X,Y,DIR) : iam(MyName) 
	& ison(MyName,X,Y,_)     
<-  -walkingfailed;
    -walkfailscount(_);
    +walkfailscount(0);
    -stepcount(_);
    +stepcount(0).
    
   
+!walkTo(X,Y,DIR): not walkingfailed 
    & walkfailscount(FailesCount) 
    & walkingfailstolerance(Maxfailes)
    & FailesCount <= Maxfailes 
    & stepcount(StepCount)
	& succstepsreconsider(MaxSteps)
	& MaxSteps > StepCount   
<-  !doOneStep(X,Y,DIR);  
    !walkTo(X, Y,DIR).
        
+!walkTo(X,Y,DIR): walkingfailed 
<-  -walkingfailed;
    -walkfailscount(_);
    +walkfailscount(0);
    -stepcount(_);
    +stepcount(0);
    .fail. 
           
+!doOneStep(X,Y,DIR)  : stepcount(StepCount)
	& succstepsreconsider(MaxSteps)
	& MaxSteps > StepCount
<-	?iam(MyName); 
    ?ison(MyName,X1,Y1,_);
    ?time(T);  
    //Astar Parameter        
    ?surroundCows(SC);
    ?ignoreFences(IF);
    ?ignoreAlly(IA);          
    edu.udo.cs.ie.cowbots.internalActions.experimental.exAstar(X1,Y1,X,Y,A,T,SC,IF,IA,DIR);
    A;
    edu.udo.cs.ie.cowbots.internalActions.getExpectedCoordinates(X1, Y1, A, ExpX, ExpY);
    ?ison(MyName,ActX,ActY,_);
    ?ison(MyName,ExpX, ExpY,_);        
    -walkfailscount(_);
    +walkfailscount(0);
    // Remember successfull steps
    ?stepcount(StepCount);
    NewStepCount=StepCount+1;
    -stepcount(_);
    +stepcount(NewStepCount).
    
            
-!doOneStep(X,Y,DIR) : not walkingfailed 
    & walkfailscount(FailesCount) 
    & walkingfailstolerance(Maxfailes)
    & FailesCount<Maxfailes   
<-	NewFailesCount=FailesCount+1;
    -walkfailscount(_);
    +walkfailscount(NewFailesCount).
        
 -!doOneStep(X,Y,DIR) : walkfailscount(FailesCount) 
 	& walkingfailstolerance(Maxfailes)
    & FailesCount>=Maxfailes   
<-	-walkfailscount(_);
    +walkfailscount(0);
    +walkingfailed .
                   
  


// Plans to assure that the Reach Plan passes fences from switch positions
        
 +!careForSwitch(A) : 
 	iam(N) & ison(N, X, Y, _) 
 	& ison(S, XS, YS, _) & edu.udo.cs.ie.cowbots.internalActions.scout.distanceToCP(X, Y, XS, YS, D) 
 	& (D = 1) & switch(S) &
 	ison(F, XF, YF, _) & relateDirection(A, DX, DY) & XF = (X + (DX - 1)) 
 	& YF = (Y + (DY -1)) & fence(F)
 <-
 	.print("muss mich vom Switch wegbewegen, bevor ich auf den Fence laufen kann");
 	!stepAwayFromSwitch(A,X,Y,XS,YS).

 
                   
                   
 +!careForSwitch(A)
 <- 
 	//.print("kein Switch im Weg");
 	A.
  	
      
 +!stepAwayFromSwitch(A,X,Y,XS,YS) :
 	X = XS
 <-	//.print("xachse gleich: ",X, XS);
 	?relateWalkAlternatives(A, B, C);
 	C;
 	B.
 
   
 +!stepAwayFromSwitch(A,X,Y,XF,YS) :
 	Y = YS
 <-	//.print("yachse gleich: ",Y, YS);
 	?relateWalkAlternatives(A, B, C);
 	B;
 	C.
 
 +!stepAwayFromSwitch(A,X,_,XS,_)
 <-	//.print("sonst: ",X, XS);
 	A.    
 